#import "FlutterPaudioPlugin.h"
#import <AVFoundation/AVFoundation.h>

@interface FlutterPaudioPlugin ()
@property(nonatomic, strong) AVAudioPlayer *player;
@end

@implementation FlutterPaudioPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"flutter_paudio"
            binaryMessenger:[registrar messenger]];
  FlutterPaudioPlugin* instance = [[FlutterPaudioPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"playAudio" isEqualToString:call.method]) {
    FlutterStandardTypedData *typedData = call.arguments;
    NSData *data =typedData.data;
    NSLog(@"%d", data.length);
    NSLog(@"playAudio");
    double duration = [self playAudio: data];
    result(@(duration));
  } else if ([@"stopAudio" isEqualToString:call.method]) {
    [self.player stop];
    result(@"success");
  } else {
    result(FlutterMethodNotImplemented);
  }
}

-(double)playAudio:(NSData *)data{   
  AVAudioPlayer *player = [[AVAudioPlayer alloc] initWithData:data error:nil];
  self.player = player;
  [player prepareToPlay];
  [player play];
  
  
  double duration = player.duration;
  // AVAudioFormat* format = player.format;
  // duration = duration*(25600/format.sampleRate);
  return duration;
}

-(void)stopAudio{
  [self.player stop];
}

@end
